////////////////////////////////////////////////////////////////////////
// starfield.c
// 2D Star Field
// Mochilote - www.cpcmania.com
////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void SetMode0PixelColor(unsigned char *pByteAddress, unsigned char nColor, unsigned char nPixel)
{
	unsigned char nByte = *pByteAddress;

	if(nPixel == 0)
	{
		nByte &= 85;

		if(nColor & 1)
			nByte |= 128;

		if(nColor & 2)
			nByte |= 8;

		if(nColor & 4)
			nByte |= 32;

		if(nColor & 8)
			nByte |= 2;
	}
	else
	{
		nByte &= 170;

		if(nColor & 1)
			nByte |= 64;

		if(nColor & 2)
			nByte |= 4;

		if(nColor & 4)
			nByte |= 16;

		if(nColor & 8)
			nByte |= 1;
	}

	*pByteAddress = nByte;
}

void PutPixelMode0(unsigned char nX, unsigned char nY, unsigned char nColor)
{
	unsigned char nPixel = 0;
	unsigned int nAddress = 0xC000 + ((nY / 8) * 80) + ((nY % 8) * 2048) + (nX / 2);
	nPixel = nX % 2;

	SetMode0PixelColor((unsigned char *)nAddress, nColor, nPixel);
}

struct _tStar
{
	unsigned char nX;
	unsigned char nY;
	unsigned char nStarType;
};

#define STARS_NUM 40
struct _tStar aStars[STARS_NUM];

void main()
{
	unsigned char nStar = 0;
	memset(aStars, 0, sizeof(aStars));
	
	//SCR_SET_MODE 0
	__asm
		ld a, #0
		call #0xBC0E
	__endasm;

	//PALETE
	__asm
		ld a, #0
		ld b, #0 ;black
		ld c, b
		call #0xBC32 ;SCR SET INK

		ld a, #1
		ld b, #12 ;Yellow
		ld c, b
		call #0xBC32 ;SCR SET INK

		ld a, #2
		ld b, #25 ;Pastel Yellow		
		ld c, b
		call #0xBC32 ;SCR SET INK

		ld a, #3
		ld b, #24 ;Bright Yellow
		ld c, b
		call #0xBC32 ;SCR SET INK
	__endasm;

	//SCR SET BORDER 0
	__asm
		ld b, #0 ;black
		ld c, b
		call #0xBC38
	__endasm;

	//Init
	for(nStar = 0; nStar < STARS_NUM; nStar++)
	{
		aStars[nStar].nX = rand() % 160;
		aStars[nStar].nY = rand() % 200;
		aStars[nStar].nStarType = rand() % 3;
	}

	while(1)
	{

		for(nStar = 0; nStar < STARS_NUM; nStar++)
		{
			//delete star
			PutPixelMode0(aStars[nStar].nX, aStars[nStar].nY, 0);

			//move star
			switch(aStars[nStar].nStarType)
			{
				case 0: //slow star
					aStars[nStar].nX += 1;
					break;
				case 1: //medium star
					aStars[nStar].nX += 2;
					break;
				case 2: //fast star
					aStars[nStar].nX += 3;
					break;
			}
			
			if(aStars[nStar].nX >= 160)
			{
				aStars[nStar].nX = 0;
				aStars[nStar].nY = rand() % 200;
				aStars[nStar].nStarType = rand() % 3;
				continue;
			}

			//paint star
			PutPixelMode0(aStars[nStar].nX, aStars[nStar].nY, aStars[nStar].nStarType + 1);
		}
	}
}
////////////////////////////////////////////////////////////////////////